<template>
  <div>
    <v-row>
      <v-col>
        <v-btn
          large
          fab
          :color="buttonColor"
          @click="toggleConnection"
          :loading="button_loading"
          :disabled="!connector_abled"
        >
          <v-icon>{{ buttonIcon }}</v-icon>
        </v-btn>
      </v-col></v-row
    >
    <v-row
      ><v-col>
        <v-btn
          small
          fab
          color="info"
          @click="skip"
          :disabled="!isRunning || !skip_abled"
        >
          <v-icon>mdi-skip-next</v-icon>
        </v-btn>
      </v-col>
    </v-row>
  </div>
</template>

<script>
import { experiment } from "@/plugins/experiment.js";
import { EventBus } from "@/plugins/bus.js";

export default {
  name: "Connector",
  data: () => ({
    button: {
      idle: {
        icon: "mdi-play",
        color: "success",
      },
      working: {
        icon: "mdi-stop",
        color: "error",
      },
    },
    button_loading: false,

    connector_abled: true,
    skip_abled: false,
  }),
  computed: {
    buttonColor() {
      return this.button[this.status].color;
    },
    buttonIcon() {
      return this.button[this.status].icon;
    },
    status() {
      return this.$store.getters["status/isConnected"] ? "working" : "idle";
    },
    isRunning() {
      return this.$store.getters["status/isRunning"];
    },
  },
  methods: {
    toggleConnection() {
      this.button_loading = true;
      this.connector_abled = false;
      this.skip_abled = false;

      let wantToConnect = !this.$store.getters["status/isConnected"];
      let message = wantToConnect ? "Connecting..." : "Disconnecting...";
      this.$notify.info(message);

      if (wantToConnect) {
        experiment.start().then(
          function (res) {
            this.$notify(res);
            this.button_loading = false;
            this.connector_abled = true;
            this.skip_abled = true;
            experiment.start_experiment();
          }.bind(this)
        );
      } else {
        experiment.stop().then(
          function (res) {
            this.$notify(res);
            this.button_loading = false;
            this.connector_abled = true;
            this.skip_abled = true;
          }.bind(this)
        );
      }
    },
    skip() {
      EventBus.$emit("stop_timer");
    },
  },
  mounted() {
    EventBus.$on("invoke_manualDisconnect", this.toggleConnection);
  },
};
</script>